import {
  GridFieldColumnController,
  GridRowController,
} from '@ibiz-template/controller';
import { computed, defineComponent } from 'vue';
import { useNamespace } from '@ibiz-template/vue-util';

export const GridFieldColumn = defineComponent({
  name: 'GridFieldColumn',
  props: {
    controller: {
      type: GridFieldColumnController,
      required: true,
    },
    row: {
      type: GridRowController,
      required: true,
    },
  },
  setup(props) {
    const ns = useNamespace('grid-column');
    const codeListText = computed(() => {
      if (props.controller.codeListItems?.length) {
        const value = props.row.data[props.controller.model.codeName];
        const findItem = props.controller.codeListItems.find(
          item => item.value === value,
        );
        return findItem?.text;
      }
      return null;
    });

    return { ns, codeListText };
  },
  render() {
    const value = this.row.data[this.controller.model.codeName];
    return <span class={this.ns.b()}>{this.codeListText || value}</span>;
  },
});
export default GridFieldColumn;
